package com.kontio;

import java.io.IOException;
import java.io.OutputStream;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.lcdui.*;
import java.io.*;
import java.util.*;
import org.kxml.*;
import org.kxml.parser.*;

public class HTTPConnectionWrapper {

	private String url 		    = null;
	private List list = null;
	private boolean inside = false;
	private Vector v = new Vector(10);


	public HTTPConnectionWrapper(){
	}

	public List fetch(){
		HttpConnection con	= null;
		InputStream is	= null;
		String xml = new String();
		OutputStream out	= null;
		try {
			con =
				(HttpConnection)Connector.open(this.url,
				Connector.READ_WRITE);
			con.setRequestMethod(HttpConnection.GET);
			is	= con.openInputStream();

			// Read the XML file from the...
			ByteArrayOutputStream bas = new ByteArrayOutputStream();
			int ch;
			while ((ch = is.read()) != -1) {
				bas.write(ch);
			}

			// Parsing the xml
			xml = bas.toString();
			parseNews(xml);

			// Creating the menu
			list = new List("XML News", List.IMPLICIT);
			int i=0;
			for (Enumeration e = v.elements() ; e.hasMoreElements() ; i++) {
			         list.append((String)(e.nextElement()), null);
			}

			int rCode 		= con.getResponseCode();
			String rMesg 	= con.getResponseMessage();

		} catch (Exception e) {
			System.out.println("Exception " +e.getMessage());
		} finally {
			try {
				if (null!=out) out.close();
				if (null!= is) is.close();
				con.close();
			} catch (Exception ex) {
				System.out.println("Exception while closing connection.");
			}
		}
		return list;
	}

	private void parseNews(String xml){
      ByteArrayInputStream bin =  new ByteArrayInputStream(xml.getBytes());
      try{
		  XmlParser parser = new XmlParser(new InputStreamReader(bin));
		  traverse(parser);
	  }
	  catch(Exception e) {
		  System.out.println("Exception while parsing XML file.");
      }
    }

    private void traverse(XmlParser parser) throws IOException {
      boolean leave = false;
      do {
          ParseEvent event = parser.read ();

          switch (event.getType ()) {
          case Xml.START_TAG:
              if (event.getName().equals("title")) inside=true;
              traverse (parser);
              break;

          case Xml.END_TAG:
              leave = true;
              inside = false;
              break;

          case Xml.END_DOCUMENT:
              leave = true;
              break;

          case Xml.TEXT:
             if (inside) {
               v.addElement(event.getText());
             }

              break;

          case Xml.WHITESPACE:
              break;

          default:
          }
      }
      while (!leave);
    }

	public void setURL(String newURL) {
		this.url = newURL;
	}

	public String getURL() {
		return this.url;
	}

}
